namespace CommunityPatch.Patches.Perks.Endurance.Riding {

  public partial class NomadicTraditionsPatch {

    public static readonly byte[][] HashesPureSpeed = {
      new byte[] {
        // e1.2.0.226110
        0x61, 0xD7, 0x4D, 0xF5, 0xB0, 0x0E, 0x84, 0x52,
        0xDC, 0xCB, 0x2F, 0xE7, 0xE2, 0x20, 0x38, 0x10,
        0x87, 0x01, 0xE3, 0x61, 0xF1, 0xAB, 0x89, 0x7D,
        0x9C, 0xDC, 0x50, 0x6E, 0xA6, 0x7E, 0xEB, 0xEF
      }
    };

    public static readonly byte[][] HashesCavalryRatioModifier = {
      new byte[] {
        // e1.2.0.226110
        0xAF, 0x54, 0x52, 0x23, 0x2B, 0xBE, 0x19, 0x6E,
        0x73, 0x75, 0xC1, 0x6E, 0x10, 0x2C, 0xEB, 0xD2,
        0x50, 0x7F, 0x48, 0xCE, 0x2D, 0xBA, 0x77, 0xCE,
        0x1D, 0x82, 0xB9, 0x4A, 0x26, 0x4B, 0xB8, 0xFA
      }
    };

    public static readonly byte[][] HashesMountedFootmenRatioModifier = {
      new byte[] {
        // e1.2.0.226110
        0x04, 0x9E, 0x68, 0x08, 0x36, 0x8C, 0xDC, 0x58,
        0x6A, 0x91, 0x16, 0x9B, 0x1B, 0x32, 0x1D, 0x06,
        0xCA, 0x08, 0xC5, 0x82, 0xA9, 0x9C, 0x69, 0x66,
        0x3E, 0x9D, 0xE9, 0x6A, 0xAE, 0x70, 0x27, 0x14
      }
    };

    public static readonly byte[][] HashesBaseSpeedForParty = {
      new byte[] {
        // e1.2.0.226110
        0xCE, 0xEC, 0x8D, 0x04, 0x4F, 0xFC, 0x58, 0x37,
        0xF9, 0xFD, 0xE9, 0x21, 0xD7, 0xDB, 0xAE, 0x12,
        0xDC, 0x46, 0x62, 0x3E, 0xE1, 0x80, 0xE8, 0x4A,
        0x28, 0xD3, 0x12, 0x36, 0x8B, 0x5B, 0xB2, 0x74
      }
    };

    private static bool HashesMatch()
      => PureSpeedMethodInfo.MakeCilSignatureSha256().MatchesAnySha256(HashesPureSpeed) &&
        CavalryRatioModifierMethodInfo.MakeCilSignatureSha256().MatchesAnySha256(HashesCavalryRatioModifier) &&
        MountedFootmenRatioModifierMethodInfo.MakeCilSignatureSha256().MatchesAnySha256(HashesMountedFootmenRatioModifier) &&
        BaseSpeedMethodInfo.MakeCilSignatureSha256().MatchesAnySha256(HashesBaseSpeedForParty);

  }

}